<template>
  <section>
    <h1 class="content text-xl">Images</h1>
    <div class="content flex items-center py-10 gap-x-10">
      <NuxtLink
        to="/admin/images/create"
        class="text-green-400 text-lg font-semibold cursor-pointer uppercase transition hover:text-pink-400"
      >
        Add Image
      </NuxtLink>
      <button
        v-if="selectedImgId"
        class="bg-red-600 rounded text-white p-2"
        @click="deleteImage"
      >
        Delete {{ selectedImgName }}
      </button>
    </div>
    <div class="content py-20">
      <div class="grid grid-cols-4 gap-10">
        <div
          class="h-[300px]"
          v-for="(image, index) in data?.images"
          :key="index"
          @click="selectImg(image)"
        >
          <img
            :src="`${image.path}${image.fileName}_large.${image.format}`"
            :alt="image.name"
            class="w-full h-full object-cover border-[6px] border-solid"
            :class="
              selectedImgId === image?.id
                ? 'border-blue-400'
                : 'border-transparent'
            "
          />
        </div>
      </div>
    </div>
  </section>
</template>

<script setup lang="ts">
import { Image } from ".prisma/client";

const { data, refresh } = await useFetch("/api/image/all");

const selectedImgId = ref<string | null>(null);
const selectedImgName = ref<string | null>(null);

const selectImg = (image: Image) => {
  selectedImgId.value = image.id;
  selectedImgName.value = image.name;
};

const deleteImage = async () => {
  try {
    const im = await $fetch("/api/image/all")
    const image = await $fetch("/api/image/delete", {
      method: "delete",
      params: {
        id: selectedImgId.value,
      },
    });

    console.log("image", image);
    refresh();
  } catch (error: any) {
    alert(error.message);
    console.error(error);
  }
};
</script>

<style scoped></style>
